#include <mpi.h>;

int main(int argc, char *argv[])
{
  int          myrank;
  int world_size, universe_size, *universe_sizep, flag;
  int spawnerror;
  int value = 123;
  void *buf = &value;
  MPI_Comm child_comm;

  if (MPI_Init(&argc,&argv)!=MPI_SUCCESS)
  {
    printf("MPI_Init failed");
  }

  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  printf("Main rank %d\n",myrank);

  MPI_Comm_size(MPI_COMM_WORLD, &world_size);
  printf("Main world_size %d\n",world_size);

  MPI_Attr_get(MPI_COMM_WORLD, MPI_UNIVERSE_SIZE,
  &universe_sizep, &flag);
  if (!flag)
  {
    printf("This MPI does not support UNIVERSE_SIZE. How many processes total?");
    scanf("%d", &universe_size);
  } else universe_size = *universe_sizep;
  printf("Main universe size %d\n",universe_size);

  char* hiargv[1];
  char h0[]={"23"};
  hiargv[0]=h0;
  for(int i = 1; i <= 2; i++)
  {
    value = 123*i;
    printf("before spawn %d\n",i);
    MPI_Comm_spawn("./hi",hiargv, 1, MPI_INFO_NULL, myrank, MPI_COMM_SELF, &child_comm, &spawnerror);
    printf("after spawn\n");
    printf("before send %d\n",value);
    MPI_Send(buf, 1, MPI_INTEGER, 0, 1, child_comm);
    printf("after send\n");
    printf("===================================\n");
  }

  MPI_Finalize();
  return 0;
}
